using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Hermes._1_Datos
{
    public class HRM_AlbaranPerfil_Lineas_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            throw new NotImplementedException();
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 2;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                 " SELECT " +
                      nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.id) + "," +
                      nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.idArticulo) + "," +
                      nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.idArticuloComodin) + "," +
                      nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.descripcionArticuloComodin) + "," +
                      nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.idAlbaranPerfilCabecera) + "," +
                      nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.tipo) + "," +
                      nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.orden) + "," +
                      nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.fechaBorrado) + "," +
                      nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.noMostrarSiCero) +
                  " FROM " + nameof(HRM_AlbaranPerfil_Lineas) +
                  " WHERE " + nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.fechaBorrado) + " IS NULL AND " +
                              nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<HRM_AlbaranPerfil_Lineas>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar Tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //MAE_Articulos ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idArticulo!=null)
                    {
                        ThreadStart obj_ThreadStart_ARTICULO = new ThreadStart(Obtener_Articulo_Modelo_Obtener);
                        Thread obj_Thread_ARTICULO = new Thread(obj_ThreadStart_ARTICULO);
                        obj_Thread_ARTICULO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //MAE_ArticulosComodin ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idArticuloComodin != null)
                    {
                        ThreadStart obj_ThreadStart_ARTICULOCOMODIN = new ThreadStart(Obtener_ArticuloComodin_Modelo_Obtener);
                        Thread obj_Thread_ARTICULOCOMODIN = new Thread(obj_ThreadStart_ARTICULOCOMODIN);
                        obj_Thread_ARTICULOCOMODIN.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[1] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_AlbaranPerfil_Lineas_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }

        #region Tablas Relacionadas
        private void Obtener_Articulo_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEARTICULOS_OBTENER_MODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idArticulo };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.MAE_Articulos = (MAE_Articulos)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_ArticuloComodin_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEARTICULOSCOMODIN_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idArticuloComodin };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.MAE_ArticulosComodin = (MAE_ArticulosComodin)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region MODELOS

        #region Modelos Simple
        private HRM_AlbaranPerfil_Lineas g_mdl_HRM_AlbaranPerfil_Lineas = null;

        public HRM_AlbaranPerfil_Lineas Obtener_Modelo_Por_Id(long _lng_Id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                 //WHERE
                                 " WHERE " +
                                   nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_Id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                        arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_AlbaranPerfil_Lineas_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_HRM_AlbaranPerfil_Lineas;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                             object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el Modelo
                g_mdl_HRM_AlbaranPerfil_Lineas = obj_Exferia_Entities.Database.SqlQuery<HRM_AlbaranPerfil_Lineas>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_AlbaranPerfil_Lineas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion

        #region Modelo Listado
        private List<HRM_AlbaranPerfil_Lineas> g_lst_HRM_AlbaranPerfil_Lineas = null;

        public List<HRM_AlbaranPerfil_Lineas> Obtener_ModeloListado_Por_IdAlbaranPerfilCabecera(List<long> _lst_idAlbaranPerfilCabecera)
        {
            try
            {

                if (_lst_idAlbaranPerfilCabecera != null && _lst_idAlbaranPerfilCabecera.Count > 0)
                {
                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(HRM_AlbaranPerfil_Lineas),
                                                                                            nameof(HRM_AlbaranPerfil_Lineas.idAlbaranPerfilCabecera),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_idAlbaranPerfilCabecera);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE  " +
                                            nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.fechaBorrado) + " IS null and " +
                                            str_Filtros_IDS;




                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { },
                                                     false);
                }

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_AlbaranPerfil_Lineas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdAlbaranPerfilCabecera), true);
            }

            return g_lst_HRM_AlbaranPerfil_Lineas;
        }

        public List<HRM_AlbaranPerfil_Lineas> Obtener_ModeloListado_Por_IdAlbaranPerfilCabecera(long _lng_idAlbaranPerfilCabecera,
                                                                                      bool _bol_Cargar_Articulo_ArticuloComodin)
        {
            try
            {

                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE  " + nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.fechaBorrado) + " IS null AND " +
                                                nameof(HRM_AlbaranPerfil_Lineas) + "." + nameof(HRM_AlbaranPerfil_Lineas.idAlbaranPerfilCabecera) + "=@idAlbaranPerfilCabecera ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idAlbaranPerfilCabecera",  _lng_idAlbaranPerfilCabecera)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros,
                                                 _bol_Cargar_Articulo_ArticuloComodin);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_AlbaranPerfil_Lineas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdAlbaranPerfilCabecera), true);
            }

            return g_lst_HRM_AlbaranPerfil_Lineas;
        }

        #region Ejecutar consulta
        //Listado de modelos Relacionados
        private List<MAE_Articulos> g_lst_MAE_Articulos = null;
        private List<MAE_ArticulosComodin> g_lst_MAE_ArticulosComodin = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 2;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros,
                                                      bool _bol_Cargar_Articulo_ArticuloComodin)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_HRM_AlbaranPerfil_Lineas = obj_Exferia_Entities.Database.SqlQuery<HRM_AlbaranPerfil_Lineas>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar Tablas Relacionadas
                if (g_lst_HRM_AlbaranPerfil_Lineas != null && g_lst_HRM_AlbaranPerfil_Lineas.Count > 0)
                {
                    //Si tiene que buscar alguna tabla relacionada
                    if (_bol_Cargar_Articulo_ArticuloComodin)
                    {
                        #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                        }

                        //MAE_Articulos #############################################
                        ThreadStart obj_ThreadStart_ARTICULOS = new ThreadStart(Obtener_Articulos_Modelo_Listado);
                        Thread obj_Thread_ARTICULOS = new Thread(obj_ThreadStart_ARTICULOS);
                        obj_Thread_ARTICULOS.Start();


                        //MAE_ArticulosComodin #############################################
                        ThreadStart obj_ThreadStart_ARTICULOSCOMODIN = new ThreadStart(Obtener_ArticulosComodin_Modelo_Listado);
                        Thread obj_Thread_ARTICULOSCOMODIN = new Thread(obj_ThreadStart_ARTICULOSCOMODIN);
                        obj_Thread_ARTICULOSCOMODIN.Start();

                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................
                        #endregion

                        #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                        foreach (HRM_AlbaranPerfil_Lineas mdl_HRM_AlbaranPerfil_Lineas in g_lst_HRM_AlbaranPerfil_Lineas)
                        {
                            //MAE_Articulos #############################################
                            if (mdl_HRM_AlbaranPerfil_Lineas.idArticulo!=null &&
                                g_lst_MAE_Articulos != null &&
                                g_lst_MAE_Articulos.Count > 0)
                            {
                                mdl_HRM_AlbaranPerfil_Lineas.MAE_Articulos = g_lst_MAE_Articulos.Where(m => m.id == mdl_HRM_AlbaranPerfil_Lineas.idArticulo.Value).FirstOrDefault();
                            }

                            //MAE_ArticulosComodin #############################################
                            if (mdl_HRM_AlbaranPerfil_Lineas.idArticuloComodin!=null &&
                                g_lst_MAE_ArticulosComodin != null &&
                                g_lst_MAE_ArticulosComodin.Count > 0)
                            {
                                mdl_HRM_AlbaranPerfil_Lineas.MAE_ArticulosComodin = g_lst_MAE_ArticulosComodin.Where(m => m.id == mdl_HRM_AlbaranPerfil_Lineas.idArticuloComodin.Value).FirstOrDefault();
                            }

                        }
                        #endregion

                    }
                }
                #endregion

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_AlbaranPerfil_Lineas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #region Tablas Relacionadas
        private void Obtener_Articulos_Modelo_Listado()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEARTICULOS_OBTENERMODELOLISTADO_POR_IDS, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_lst_HRM_AlbaranPerfil_Lineas.Where(m=>m.idArticulo!=null).Select(m => m.idArticulo.Value).ToList()};
                //Pasamos los parametros al metodo y lo ejecutamos
                g_lst_MAE_Articulos = (List<MAE_Articulos>)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        private void Obtener_ArticulosComodin_Modelo_Listado()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEARTICULOSCOMODIN_OBTENERMODELOLISTADO_POR_IDS, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_lst_HRM_AlbaranPerfil_Lineas.Where(m => m.idArticuloComodin != null).Select(m => m.idArticuloComodin.Value).ToList() };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_lst_MAE_ArticulosComodin = (List<MAE_ArticulosComodin>)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[1] = true;
            }
        }
        #endregion

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(HRM_AlbaranPerfil_Lineas.id) + "," +
                    nameof(HRM_AlbaranPerfil_Lineas.idArticulo) + "," +
                    nameof(HRM_AlbaranPerfil_Lineas.idArticuloComodin) + "," +
                    nameof(HRM_AlbaranPerfil_Lineas.descripcionArticuloComodin) + "," +
                    nameof(HRM_AlbaranPerfil_Lineas.idAlbaranPerfilCabecera) + "," +
                    nameof(HRM_AlbaranPerfil_Lineas.tipo) + "," +
                    nameof(HRM_AlbaranPerfil_Lineas.orden) + "," +
                    nameof(HRM_AlbaranPerfil_Lineas.fechaBorrado) + "," +
                     nameof(HRM_AlbaranPerfil_Lineas.noMostrarSiCero) +
                " FROM " + nameof(HRM_AlbaranPerfil_Lineas);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                HRM_AlbaranPerfil_Lineas mdl_HRM_AlbaranPerfil_Lineas_AGrabar = (HRM_AlbaranPerfil_Lineas)_mdl_obj;
                HRM_AlbaranPerfil_Lineas mdl_HRM_AlbaranPerfil_Lineas_DatosViejos = new HRM_AlbaranPerfil_Lineas();

                // Ver si existe ######################################################################
                HRM_AlbaranPerfil_Lineas mdl_HRM_AlbaranPerfil_Lineas_Final = Obtener_Modelo_Por_Id(mdl_HRM_AlbaranPerfil_Lineas_AGrabar.id);
                //#####################################################################################

                //UPDATE
                if (mdl_HRM_AlbaranPerfil_Lineas_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos Viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_HRM_AlbaranPerfil_Lineas_Final, mdl_HRM_AlbaranPerfil_Lineas_DatosViejos, false, false);

                    //Cargar los Datos Nuevos para la Trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_HRM_AlbaranPerfil_Lineas_AGrabar, mdl_HRM_AlbaranPerfil_Lineas_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(HRM_AlbaranPerfil_Lineas) +
                                            " SET " +
                                                nameof(HRM_AlbaranPerfil_Lineas.idArticulo) + "=@idArticulo," +
                                                nameof(HRM_AlbaranPerfil_Lineas.idArticuloComodin) + "=@idArticuloComodin," +
                                                nameof(HRM_AlbaranPerfil_Lineas.descripcionArticuloComodin) + "=@descripcionArticuloComodin," +
                                                nameof(HRM_AlbaranPerfil_Lineas.idAlbaranPerfilCabecera) + "=@idAlbaranPerfilCabecera," +
                                                nameof(HRM_AlbaranPerfil_Lineas.tipo) + "=@tipo," +
                                                nameof(HRM_AlbaranPerfil_Lineas.orden) + "=@orden," +
                                                nameof(HRM_AlbaranPerfil_Lineas.fechaBorrado) + "=@fechaBorrado," +
                                                nameof(HRM_AlbaranPerfil_Lineas.noMostrarSiCero) + "=@noMostrarSiCero" +
                                            " WHERE " +
                                                nameof(HRM_AlbaranPerfil_Lineas.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        mdl_HRM_AlbaranPerfil_Lineas_Final.idArticulo != null
                            ?   new SqlParameter("@idArticulo", mdl_HRM_AlbaranPerfil_Lineas_Final.idArticulo.Value)
                            :   new SqlParameter("@idArticulo",  DBNull.Value),
                        mdl_HRM_AlbaranPerfil_Lineas_Final.idArticuloComodin != null
                            ?   new SqlParameter("@idArticuloComodin", mdl_HRM_AlbaranPerfil_Lineas_Final.idArticuloComodin.Value)
                            :   new SqlParameter("@idArticuloComodin",  DBNull.Value),
                        mdl_HRM_AlbaranPerfil_Lineas_Final.descripcionArticuloComodin != null
                            ?   new SqlParameter("@descripcionArticuloComodin", mdl_HRM_AlbaranPerfil_Lineas_Final.descripcionArticuloComodin)
                            :   new SqlParameter("@descripcionArticuloComodin",  DBNull.Value),
                        new SqlParameter("@idAlbaranPerfilCabecera", mdl_HRM_AlbaranPerfil_Lineas_Final.idAlbaranPerfilCabecera),
                        new SqlParameter("@tipo", mdl_HRM_AlbaranPerfil_Lineas_Final.tipo),
                        new SqlParameter("@orden", mdl_HRM_AlbaranPerfil_Lineas_Final.orden),
                        mdl_HRM_AlbaranPerfil_Lineas_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_HRM_AlbaranPerfil_Lineas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        mdl_HRM_AlbaranPerfil_Lineas_Final.noMostrarSiCero != null
                            ?   new SqlParameter("@noMostrarSiCero", mdl_HRM_AlbaranPerfil_Lineas_Final.noMostrarSiCero.Value)
                            :   new SqlParameter("@noMostrarSiCero",  DBNull.Value),
                        new SqlParameter("@id", mdl_HRM_AlbaranPerfil_Lineas_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_HRM_AlbaranPerfil_Lineas_Final.id;
                }
                //INSERT
                else
                {
                    mdl_HRM_AlbaranPerfil_Lineas_Final = new HRM_AlbaranPerfil_Lineas();

                    //Tipo de Accdion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos Del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_HRM_AlbaranPerfil_Lineas_AGrabar, mdl_HRM_AlbaranPerfil_Lineas_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(HRM_AlbaranPerfil_Lineas) +
                                                " (" +
                                                        nameof(HRM_AlbaranPerfil_Lineas.idArticulo) + "," +
                                                        nameof(HRM_AlbaranPerfil_Lineas.idArticuloComodin) + "," +
                                                        nameof(HRM_AlbaranPerfil_Lineas.descripcionArticuloComodin) + "," +
                                                        nameof(HRM_AlbaranPerfil_Lineas.idAlbaranPerfilCabecera) + "," +
                                                        nameof(HRM_AlbaranPerfil_Lineas.tipo) + "," +
                                                        nameof(HRM_AlbaranPerfil_Lineas.orden) + "," +
                                                        nameof(HRM_AlbaranPerfil_Lineas.fechaBorrado) + "," +
                                                        nameof(HRM_AlbaranPerfil_Lineas.noMostrarSiCero) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(HRM_AlbaranPerfil_Lineas.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@idArticulo," +
                                                    "@idArticuloComodin," +
                                                    "@descripcionArticuloComodin," +
                                                    "@idAlbaranPerfilCabecera," +
                                                    "@tipo," +
                                                    "@orden," +
                                                    "@fechaBorrado," +
                                                    "@noMostrarSiCero" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        mdl_HRM_AlbaranPerfil_Lineas_Final.idArticulo != null
                            ?   new SqlParameter("@idArticulo", mdl_HRM_AlbaranPerfil_Lineas_Final.idArticulo.Value)
                            :   new SqlParameter("@idArticulo",  DBNull.Value),
                        mdl_HRM_AlbaranPerfil_Lineas_Final.idArticuloComodin != null
                            ?   new SqlParameter("@idArticuloComodin", mdl_HRM_AlbaranPerfil_Lineas_Final.idArticuloComodin.Value)
                            :   new SqlParameter("@idArticuloComodin",  DBNull.Value),
                        mdl_HRM_AlbaranPerfil_Lineas_Final.descripcionArticuloComodin != null
                            ?   new SqlParameter("@descripcionArticuloComodin", mdl_HRM_AlbaranPerfil_Lineas_Final.descripcionArticuloComodin)
                            :   new SqlParameter("@descripcionArticuloComodin",  DBNull.Value),
                        new SqlParameter("@idAlbaranPerfilCabecera", mdl_HRM_AlbaranPerfil_Lineas_Final.idAlbaranPerfilCabecera),
                        new SqlParameter("@tipo", mdl_HRM_AlbaranPerfil_Lineas_Final.tipo),
                        new SqlParameter("@orden", mdl_HRM_AlbaranPerfil_Lineas_Final.orden),
                        mdl_HRM_AlbaranPerfil_Lineas_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_HRM_AlbaranPerfil_Lineas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        mdl_HRM_AlbaranPerfil_Lineas_Final.noMostrarSiCero != null
                            ?   new SqlParameter("@noMostrarSiCero", mdl_HRM_AlbaranPerfil_Lineas_Final.noMostrarSiCero.Value)
                            :   new SqlParameter("@noMostrarSiCero",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(HRM_AlbaranPerfil_Lineas), mdl_HRM_AlbaranPerfil_Lineas_DatosViejos, mdl_HRM_AlbaranPerfil_Lineas_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_AlbaranPerfil_Lineas_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                HRM_AlbaranPerfil_Lineas mdl_HRM_AlbaranPerfil_Lineas_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_HRM_AlbaranPerfil_Lineas_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(HRM_AlbaranPerfil_Lineas) +
                                                " SET " +
                                                nameof(HRM_AlbaranPerfil_Lineas.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(HRM_AlbaranPerfil_Lineas.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                                 new SqlParameter("@fechaBorrado",  DateTime.Now),
                                new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(HRM_AlbaranPerfil_Lineas), null, mdl_HRM_AlbaranPerfil_Lineas_Final, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Devolver tambien el objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HRM_AlbaranPerfil_Lineas_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}
